# HTTPS
在你要设置的代理服务的基本信息设置中，点击"HTTPS"选项卡，可以查看和设置HTTPS:
![https.png](https.png)
 
HTTPS通常的端口是`443`，建议不要轻易修改。

## 检查HTTPS证书是否正确
从v0.1.2开始，上传完证书后，TeaWeb会自动显示证书信息，以便于我们检查证书是否正确。

可以在代理服务的"HTTPS"菜单对应的页面中看到这些信息：
![https-2.png](https-2.png)

## 常见问题排查
### 浏览器提示证书错误
如果你在浏览器上访问网站的时候，遇到证书错误提示，可以按下面步骤排查：
1. 确认你的代理服务已设置对应的域名，此域名要和浏览器访问的域名一致（也支持二级或多级子域名），**这个至关重要**，因为TeaWeb是根据域名来查找匹配的代理服务的；通常代理服务里的域名要把域名设置完整，比如：`teaos.cn`、`www.teaos.cn`、`api.cloud.teaos.cn`；
2. 在HTTPS页信息中"证书文件"一行信息中正确显示了域名信息，且在有效期内；
3. 确认没有别的代理服务域名设置和当前代理服务域名设置有冲突；
4. 清空浏览器缓存或者在别的电脑上尝试访问此代理服务，以确保浏览器或电脑没有缓存这些证书。

## 自动跳转到HTTPS
从v0.1.2开始，可以设置某个代理服务或者路径规则是否自动跳转到HTTPS上，开启后HTTP的请求会自动跳转到对应的HTTPS请求上：
* 代理服务：在"基本信息" -- "修改" -- "更多选项" -- "自动跳转到HTTPS"中可以设置
* 路径规则：在"路径规则" -- 单个路径规则"详情" -- "修改" -- "更多选项" -- "自动跳转到HTTPS"中可以设置。 